/* -*- Mode:C++ -*- */
/*
 * Copyright (c) Multimedia Communications Lab, Boston University
 *
 * Simulation Program to Evaluate Service Aggregation in VOD
 * =========================================================
 *
 * This work was supported by NSF under grant No. NCR-9523958
 * 
 * DISCLAIMER:
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL
 * MULTIMEDIA COMMUNICATIONS LAB, BOSTON UNIVERSITY OR THE CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Contributors:
 *
 * Rajesh Krishnan
 */

#ifndef __MOVIE_HPP__
#define __MOVIE_HPP__

#include "list.hpp"

class Movie:public Node
{
  friend class Movielist;
protected:
  double duration;
  int frequency;
  int movie_id;
  int threshold;
public:
  static int num_mov;
  Movie(double dur, int freq, int id)
    {
      duration = dur; 
      frequency = freq;
      movie_id = id;
      num_mov++;
    };
  virtual ~Movie() {num_mov--;};
  int MovieId(void) {return movie_id;};
  void SetMovieId(int mid) {movie_id = mid;};
  double Duration(void) {return duration;};
  virtual void Dumpdata(void);
};

class Movielist:public List
{
private:
  void Computethresholds(void);
public:
  static int num_movlist;
  Movielist(char *filename);
  ~Movielist() {num_movlist--;};
  Movie *Randomchoice(void);
  void Zipf_distribute(double param);
};

#endif //__MOVIE_HPP__
