/* -*- Mode:C++ -*- */
/*
 * Copyright (c) Multimedia Communications Lab, Boston University
 *
 * Simulation Program to Evaluate Service Aggregation in VOD
 * =========================================================
 *
 * This work was supported by NSF under grant No. NCR-9523958
 * 
 * DISCLAIMER:
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL
 * MULTIMEDIA COMMUNICATIONS LAB, BOSTON UNIVERSITY OR THE CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Contributors:
 *
 * Prithwish Basu
 */

#ifndef __STREAM_H__
#define __STREAM_H__

#include <iostream.h>
#include <fstream.h>

#include "interface.h"

#define Kfactor  15.0
#define CARRY_SAME_PROGRAM(x,y) ((x ^ y) ? 0:1)

/****************************************************************/
/* This denotes an EMCL cluster */
typedef struct _cluster
{ 
    int    firstmemind;
    int    lastmemind;
    double   bandwidth_reclaimed;
} CLUSTER;



/****************************************************************/
/* Utility fns. */
int      compar(const void *, const void *);
int      comparclust(const void *, const void *);
void     populate(STREAM *, int, double, int);
int      find_stream_index(double stream_id, STREAM *stream, int nstreams);
void     cluster(STREAM *streams, int nstreams, CLUSTER *clusters, double window, int *nclus, int *nchnl);
void     cluster_rsma(STREAM *streams, int nstreams, CLUSTER *clusters, int *nclus, int *nchnl);
void 	 output_streams(STREAM *streams, int nstream);
void     print_stream_id(STREAM *, CLUSTER);
void     print_stream_info(STREAM);
/****************************************************************/

#endif
